//       J3d1 j3d1adm1n@yandex.ru
//  
#include <cstdio>// printf
#include "SDL.h"
#include <cstring>//   : strcpy  strcat

// 
#define	MAX_PATH_LENGTH 128 // -     
#define	RESOURCE_PATH "res/" //  
#define PICTURE "picture.bmp" //  

//   
const int SCREEN_WIDTH= 240;
const int SCREEN_HEIGHT= 320;
const int SCREEN_BPP= 16;
const char resource_name[]= RESOURCE_PATH;
const char pict_name[]= PICTURE;
Uint32 back_color;//    
SDL_Surface *screen= NULL;//  SDL
SDL_Surface *loaded_picture=NULL;// SDL   


////////////////////////////////////////////////
//                     //
////////////////////////////////////////////////

int main( int argc, char* args[] )
{

  char res_path[MAX_PATH_LENGTH];//  
  res_path[0] = '\000';//  
  strcpy(res_path, args[0]);//     res_path

  printf("from OS=%s\n", res_path);

  if (res_path[0]!='.')//     linux  mc, ...
    {
      //   Wince
      for (unsigned int i= 0 ;i!= (strlen(res_path)-1); ++i)//   
        {
          if (res_path[i]=='\\') res_path[i]='/';//  \,   /
        }
    }

  //       -   
  for (int i= (strlen(res_path)-1);(res_path[i] !='/') && (i>=0); --i) res_path[i]='\000';

#ifndef UNDER_CE//   wince
#ifdef _WIN32//  32- windows
  res_path[0]='\000';//          Windows
#endif
#endif

  strcat(res_path, resource_name);//   
  strcat(res_path, pict_name);//  -
  printf("loading path=%s\n", res_path);

  //Start SDL
  printf("SDL initialization...\n");
  if (SDL_Init(SDL_INIT_VIDEO)== -1)
    {
      printf("SDL initializing failure!\n");
      return 1;
    }
  else printf("SDL initializing -- Ok\n");

  //Set up the screen
#ifdef UNDER_CE//  WinCE   , .      
  screen= SDL_SetVideoMode(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE | SDL_FULLSCREEN);
#else // Win32  Linux          SDL
  screen= SDL_SetVideoMode(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_HWSURFACE);
#endif

//If there was an error in setting up the screen
  if (screen== NULL)
    {
      printf("Unable to SetVideoMode\n");
      return 1;
    }
  else printf("VideoMode settings -- Ok\n");

  //   
  SDL_LockSurface(screen);
  back_color= SDL_MapRGB(screen->format, 0, 0, 0); // back_color   screen
  SDL_FillRect (screen, NULL, back_color);
  SDL_UnlockSurface(screen);
  SDL_Flip (screen);

  //      res_path
  loaded_picture= SDL_LoadBMP(res_path);
  SDL_BlitSurface(loaded_picture, NULL, screen, NULL);// 
  SDL_Flip (screen);

  SDL_Delay(4000);//        

  //  SDL  
  printf("SDL quiting...\n");
  SDL_FreeSurface(loaded_picture);
  SDL_FreeSurface(screen);
  SDL_Quit();

  return 0;
}

